#include "stdafx.h"

class CVwAcqNote : public CDialog { 
	public : 
		CDlgEdit m_edtTime;
		CDlgCombo m_cmbNote;
		CSession * m_pSes;
		HWND m_hVwClient, m_hVwSes;

		CVwAcqNote() { 
			m_iID = IDD_ACQNOTE;
			}

		void InitializeControls( ) { 
			m_edtTime.SetHandle( GetDlgItem( m_hDlg, IDC_EDTTIME ), "Sample number when [Note] was clicked" );
			m_cmbNote.SetHandle( GetDlgItem( m_hDlg, IDC_CMBNOTE ), "Note text - select from list or enter a note" );

			CString cNotes = g_oCfgs.m_oSettings.m_cDataNotes;
			int i=0, iPos=0, iLen=cNotes.Length();
			while( i<=iLen ) {
				if( cNotes[i]=='\n' || cNotes[i]=='\r' || cNotes[i]==0 ) {
					m_cmbNote.AddString( cNotes.Mid( iPos, i-iPos ).Buffer() );
					while( i<=iLen && (cNotes[i]=='\n' || cNotes[i]=='\r' || cNotes[i]==0 ) )
						++i;
					iPos=i;
					}
				else 
					++i;
				}
			}

		bool Setup( CSession * pSes ) { 
			m_pSes = pSes;
			char bufTime[32];
			sprintf( bufTime, "%d", pSes->m_iAcqPos );
			SetWindowText( GetDlgItem( m_hDlg, IDC_EDTTIME ), bufTime );
			return true;
			}
			
		void  OnBtnSave( ) { 
			if( m_pSes == NULL ) {
				MessageBox( NULL, "The session has been closed and the note cannot be saved.", "Save Acquisition Note", MB_OK );
				return;
				}
				
			CString cTm;
			m_edtTime.GetText( &cTm );
			
			CString c;
			m_cmbNote.GetText( &c );
			
			//-- Save note to session list ... 
			m_pSes->m_oQDF.AddNote( atoi(cTm.Buffer()), c.Buffer(), "" );
			
			}
			
		void OnBtnCancel( ) { 
			//
			}
	};


//-- Protocol view message handler
BOOL CALLBACK AcqNoteDlgProc(HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam) { 
	int wmId, wmEvent;
	CVwAcqNote * pVwAcqNote;
	HWND hVwSes = NULL, hVwClient = NULL;

	switch( iMsg ) { 
		case WM_INITDIALOG :
			pVwAcqNote = new CVwAcqNote;
			pVwAcqNote->m_hDlg=hDlg;
			SetWindowLong( GetParent( hDlg ), 0,  (long) pVwAcqNote ) ;
			pVwAcqNote->InitializeControls();
			return TRUE;
			
		case WM_ACQNOTESETUP : { 
			CSession * pSes = (CSession *)wParam;
			pVwAcqNote = (CVwAcqNote *) GetWindowLong(  GetParent( hDlg ), 0 );
			pVwAcqNote->Setup( pSes );
			}
			return TRUE;

		case WM_ACQNOTESETUP2 : { 
			pVwAcqNote = (CVwAcqNote *) GetWindowLong(  GetParent( hDlg ), 0 );
			pVwAcqNote->m_hVwClient = (HWND) wParam;
			pVwAcqNote->m_hVwSes = (HWND) lParam;
			}
			return TRUE;

		case WM_COMMAND : {
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam);
			pVwAcqNote = (CVwAcqNote *) GetWindowLong(  GetParent( hDlg ), 0 );

			//----- 
			if( wmId == IDC_BTNSAVE || wmId == IDOK ) {
				pVwAcqNote->OnBtnSave();
				DestroyWindow( GetParent( hDlg ) );
				return TRUE;
				}

			//----- 
			if( wmId == IDC_BTNCANCEL || wmId == IDCANCEL ) {
				pVwAcqNote->OnBtnCancel();
				DestroyWindow( GetParent( hDlg ) );
				return TRUE;
				}
			}
			return FALSE;
			
		case WM_ACQNOTE_SESSIONDESTROYED : 
			pVwAcqNote = (CVwAcqNote *) GetWindowLong(  GetParent( hDlg ), 0 );
			pVwAcqNote->m_pSes=NULL;
			DestroyWindow( GetParent( hDlg ) );
			return TRUE;
			
		case WM_DESTROY :
			pVwAcqNote = (CVwAcqNote *) GetWindowLong(  GetParent( hDlg ), 0 );
			hVwClient = pVwAcqNote->m_hVwClient;
			hVwSes = pVwAcqNote->m_hVwSes;
			delete pVwAcqNote;
			SetWindowLong( GetParent( hDlg ), 0, 0);
			WindowListRemove( hDlg );
			SendMessage( hVwClient, WM_MDIACTIVATE, (WPARAM) hVwSes, NULL );
			return TRUE;

		default : 
			break;
		}
		
	return FALSE;
	} 
